;==============================================================================
;
; MSX1 X^[tH[X
;
;	n㕨()
;
;==============================================================================
org				#4000
prog_end	equ	#e000


public	decode_bigora
decode_bigora:
		and		#7
		cp		4

		ld		hl,pcg_data_0+4
		ld		de,#e800
		jr		c,_decode
		ld		hl,pcg_data_1+4
	_decode:
		push	af
		call	DECODE_LZE
		pop		af

		and		#3
		ld		hl,#e800
		add		a,h
		ld		h,a
		ld		de,#e800
		ld		bc,#100
		ldir

		ld		a,#05
		call	_write_pcg
		ld		a,#0d
		call	_write_pcg
		ld		a,#15
	_write_pcg:
		push	af
		ld		hl,#e800
		ld		de,(#f3cb)
		call	_write_vram_x80
		pop		af
		ld		hl,#e880
		ld		de,(#f3c9)
	_write_vram_x80:
		add		a,d
		ld		d,a
		ld		b,#80
	_write_vram:
		ld		a,(#0007)
		ld		c,a
		inc		c
		out		(c),e
		ld		a,d
		and		#3f
		or		#40
		out		(c),a
		dec		c

	_otir:
		outi
		jp		nz,_otir
		ret



;//	LZE DECODE ROUTINE
;//	Original Copyright (C)1995,2008 GORRY.
;//	Porting for Z80 by Kei Moroboshi 2017/SEP.
	.Z80

;	PUBLIC	DECODE_LZE
;================================================
;LZEf[^fR[hB
;in	HL	fR[hOf[^ւ̃|C^
;	DE	fR[hf[^ւ̃|C^
;================================================

DECODE_LZE:
	PUSH	DE
	EXX
	POP	DE
	EXX

	LD	B,1	;BitCount=1
DECODE_LZE_lp0:
DECODE_LZE_1:
	LD	A,(HL)	;*(DECODEPtr++) = *(LZEPtr++);
	INC	HL
	EXX
	LD	(DE),A	;DE'=DECODEPtr
	INC	DE
	EXX

DECODE_LZE_lp1:
	DJNZ	SKIP	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP:	SLA	C	;	BitData <<= 1;

	JR	C,DECODE_LZE_1	;jc	DECODE_LZE_1

DECODE_LZE_0:
	EXX
	LD	HL,-1	;Distance=-1;
	EXX
	DJNZ	SKIP0	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP0:	SLA	C	;	BitData <<= 1;

	JR	C,DECODE_LZE_01	;jc	DECODE_LZE_01
DECODE_LZE_00:
	DJNZ	SKIP00	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP00:	SLA	C	;	BitData <<= 1;
	EXX
	LD	BC,0	;CopyCount = 0;
	RL	C
	RL	B	;adc	CopyCount,CopyCount
	EXX
	DJNZ	SKIP01	;if ( (--BitCount) == 0 ) {
	LD	C,(HL)	;	BitData = (int)*(LZEPtr++);
	INC	HL
	LD	B,8	;	BitCount = 8;
SKIP01:	SLA	C	;	BitData <<= 1;
	LD	A,(HL)	;	Distance = -256+((int)*(LZEPtr++));
	INC	HL
	EXX
	LD	L,A
	RL	C	;adc	CopyCount,CopyCount
	RL	B
DECODE_LZE_00_1:
	INC	BC	;inc	CopyCount
DECODE_LZE_00_2:
	ADD	HL,DE	;HL':CopyPtr=HL:Distance + DE':DECODEPtr
	INC	BC	;inc	CopyCount
	LDIR		;copy
	EXX
	JP	DECODE_LZE_lp1	;[[[ or JR ]]]

DECODE_LZE_01:
	LD	A,(HL)
	INC	HL
	EX	AF,AF'
	LD	A,(HL)
	INC	HL
	EXX
	LD	L,A
	EX	AF,AF'
;	LD	H,A
	LD	C,L		;mov	CopyCount,Distance
;	LD	B,H
;	LD	A,H
	RRA			;shr	Distance,1
	RR	L
	RRA			;shr	Distance,1
	RR	L
	RRA			;shr	Distance,1
	RR	L
	OR	0E0H		;or	DistanceH,0e0h
	LD	H,A

	LD	B,0
	LD	A,C
	AND	7		;and	CopyCount,7
	LD	C,A
	JP	NZ,DECODE_LZE_00_1	;[[[ or JR ]]]
 	EXX
	LD	A,(HL)
	INC	HL
	EXX
	LD	C,A	;C'=CopyCountL
	OR	A
	JP	NZ,DECODE_LZE_00_2	;[[[ or JR ]]]

;	EXX
DECODE_LZE_e:
	RET


pcg_data_0:
incbin	"StarForce-bigoras-0-3.lze"

pcg_data_1:
incbin	"StarForce-bigoras-4-7.lze"


filler:
		ds	prog_end-#ff-filler
i_am_ascii_8:
		rept	85
			db	#32,#00,#68
		endm
end
